bwa2018djangoproject/urls.py
from django.contrib import admin
from django.urls import path, include
from . import views


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.index, name="landing_page"),
    path('err404', views.not_found, name="error_404"),
    path('err500', views.error_500, name="error_500"),
    path('members/', include('members.urls')),
    path('discussions/', include('discussions.urls')),
]

discussions/urls.py
from django.urls import path
from discussions.views import discussion_view, DiscussionHandler, MessageHandler

app_name = 'discussions'

urlpatterns = [
path('message/', MessageHandler.as_view(), name='message'),
    path('discussion/<discussion_id>', DiscussionHandler.as_view(), name='discussion'),
    path('', discussion_view, name='discussion_view'),
]

members/urls.py
from django.urls import path
from members.views import SignUp, SignIn, profile, Friends, FriendRequestHandler, friends_view, logout, StatusHandler, \
    CommentHandler, UserInformation, delete_user

app_name = 'members'

urlpatterns = [
    path('login/', SignIn.as_view(), name='login'),
    path('signup/', SignUp.as_view(), name='signup'),
    path('info/<username>', UserInformation.as_view(), name='information'),
    path('profile/<username>', profile, name='profile'),
    path('friendsview/<username>', friends_view, name='friends_view'),
    path('friends/<username>', Friends.as_view(), name='friends'),
    path('friendrequest/<username>', FriendRequestHandler.as_view(), name='friend_requests'),
    path('friends/<username>', Friends.as_view(), name='friends'),
    path('logout', logout, name='logout'),
    path('status/', StatusHandler.as_view(), name='status'),
    path('comment/', CommentHandler.as_view(), name='comment'),
    path('delete', delete_user, name='delete')
]

bwa2018djangoproject/views.py
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.shortcuts import render, redirect


def index(request):
    return HttpResponseRedirect(reverse('members:login'))


def not_found(request):
    return render(request, "not_found.html")

def error_500(request):
    return render(request, "error_500.html")

bwa2018djangoproject/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Nelin {% block title %}
    {% endblock %}</title>
    {% load static %}
    <link href="{% static "bootstrap/css/bootstrap.css" %}" rel="stylesheet">
    <link href="{% static "css/nelin.css" %}" rel="stylesheet">
    <script defer src="https://use.fontawesome.com/releases/v5.5.0/js/all.js"
            integrity="sha384-GqVMZRt5Gn7tB9D9q7ONtcp4gtHIUEW/yG7h98J7IpE3kpi+srfFyyB/04OV6pG0"
            crossorigin="anonymous"></script>
    <script src="{% static "js/jquery-3.3.1.min.js" %}"></script>
    <script src="{% static "bootstrap/js/bootstrap.js" %}"></script>
    <script src="{% static "js/page_load_proress.js" %}"></script>

</head>

<body>

<nav class="navbar navbar-expand-md navbar-light bg-light mb-4">
    <a class="navbar-brand" href="{% url "members:login" %}">Nelin</a>

    {% if request.user.is_authenticated %}
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse"
                aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarCollapse">
        <ul class="nav navbar-nav mr-auto">
            <li class="nav-item {% if is_profile %}active{% endif %}">
                <a class="nav-link " href="{% url "members:profile" request.user.username %}">Profile </a>
            </li>
            <li class="nav-item {% if is_friends %}active{% endif %}">
                <a class="nav-link" href="{% url "members:friends_view" request.user.username %}">Friends </a>
            </li>
            <li class="nav-item {% if is_discussion %}active{% endif %}">
                <a class="nav-link" href="{%  url "discussions:discussion_view"  %}">Discussions </a>
            </li>
        </ul>
        <div class="signout float-right">
                <a class="nav-link " href="{% url "members:logout" %}"><i class="fas fa-sign-out-alt"></i></a>
            </div>
    {% endif %}

</nav>

{% csrf_token %}
<script>
    // globally used variables
    const csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    const formateDate = (date_value)=>{
        date = new Date(date_value);
        return `${date.getFullYear()}-${date.getMonth()}-${date.getDate()} ${date.getHours()}:${date.getMinutes()}:${date.getSeconds()}`;
    };

    const creatreUserProfileUrl = (username)=>{return '{% url "members:profile" ":username:" %}'.replace(':username:',username)};
    const creatreDiscussionUrl = (discussion_id)=>{return '{% url "discussions:discussion" ":discussion:" %}'.replace(':discussion:',discussion_id)};
    const isOwner  = (username)=>{
        const currentUsername ='{{ request.user.username }}';
        return username && currentUsername && username === currentUsername;
    };

</script>

{% block content %}
{% endblock %}

</body>
</html>

bwa2018djangoproject/templates/error_500.html
{% extends 'base.html' %}


{% block content %}
    <div class="container-fluid">
        <div class="row align-items-center justify-content-center">
            <div class="col-lg-6 col-md-10 col-sm-12">
                {% load static %}
                <img alt="un expected error code 500" src="{% static "images/500.jpg" %}"/>
            </div>
        </div>
    </div>

{% endblock %}

bwa2018djangoproject/templates/index.html
{% extends "base.html" %}

{% block content %}
    {{ message }}
{% endblock %}

bwa2018djangoproject/templates/not_found.html
{% extends 'base.html' %}


{% block content %}
    <div class="container-fluid">
        <div class="row align-items-center justify-content-center">
            <div class="col-lg-6 col-md-10 col-sm-12">
                {% load static %}
                <img alt="404 image" src="{% static "images/404.png" %}"/>
            </div>
        </div>
    </div>

{% endblock %}